// MDIDOCVIEW.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MDIDOCVIEW.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "MDIDOCVIEWDoc.h"
#include "MDIDOCVIEWView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMDIDOCVIEWApp

BEGIN_MESSAGE_MAP(CMDIDOCVIEWApp, CWinApp)
	//{{AFX_MSG_MAP(CMDIDOCVIEWApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMDIDOCVIEWApp construction

CMDIDOCVIEWApp::CMDIDOCVIEWApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMDIDOCVIEWApp object

CMDIDOCVIEWApp theApp;

/////////////////////////////////////////////////////////////////////////////
// Prof-UIS advanced options

void CMDIDOCVIEWApp::SetupUiAdvancedOptions()
{
	ASSERT( m_pszRegistryKey != NULL );
	ASSERT( m_pszRegistryKey[0] != _T('\0') );
	ASSERT( m_pszProfileName != NULL );
	ASSERT( m_pszProfileName[0] != _T('\0') );

	//
	// Prof-UIS command manager profile
	//
	VERIFY(
		g_CmdManager->ProfileSetup( m_pszProfileName )
		);

	//
	// General UI look
    //
// UNCOMMENT THESE LINES FOR OFFICE 2000 UI STYLE
//	g_PaintManager.InstallPaintManager(
//		new CExtPaintManager
//	);

	//
	// Popup menu option: Display menu shadows
    //
	CExtPopupMenuWnd::g_bMenuWithShadows = true;

	//
	// Popup menu option: Display menu cool tips
    //
	CExtPopupMenuWnd::g_bMenuShowCoolTips = true;

	//
	// Popup menu option: Initially hide rarely used items (RUI)
    //
	CExtPopupMenuWnd::g_bMenuExpanding = true;

	//
	// Popup menu option: Display RUI in different style
    //
	CExtPopupMenuWnd::g_bMenuHighlightRarely = true;

	//
	// Popup menu option: Animate when expanding RUI (like Office XP)
    //
	CExtPopupMenuWnd::g_bMenuExpandAnimation = true;

	//
	// Popup menu option: Align to desktop work area (false - to screen area)
    //
	CExtPopupMenuWnd::g_bUseDesktopWorkArea = true;

	//
	// Popup menu option: Popup menu animation effect (when displaying)
    //
	CExtPopupMenuWnd::g_DefAnimationType =
		CExtPopupMenuWnd::__AT_FADE;

}

/////////////////////////////////////////////////////////////////////////////
// CMDIDOCVIEWApp initialization

BOOL CMDIDOCVIEWApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#if _MFC_VER < 0x700
	#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
	#else
		Enable3dControlsStatic();	// Call this when linking to MFC statically
	#endif
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey( _T("Foss") );
	ASSERT( m_pszRegistryKey != NULL );

    // Change the application profile name (usually product name).
	// NOTE: The CWinApp class destructor will free the memory automatically.
	if( m_pszProfileName != NULL )
		free( (void*)m_pszProfileName );
	m_pszProfileName =
		_tcsdup( _T("MDIDOCVIEW") );
	ASSERT( m_pszProfileName != NULL );

	//
	// Prof-UIS advanced options
    //
	SetupUiAdvancedOptions();

	LoadStdProfileSettings(16);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_MDIDOCTYPE,
		RUNTIME_CLASS(CMDIDOCVIEWDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CMDIDOCVIEWView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ActivateFrame( m_nCmdShow );
//	pMainFrame->ShowWindow(m_nCmdShow);
//	pMainFrame->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CExtResizableDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CExtButton	m_BtnOK;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CExtResizableDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CExtResizableDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDOK, m_BtnOK);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CExtResizableDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog()
{
	VERIFY( CExtResizableDialog::OnInitDialog() );

	//
	// Show size gripper
    //
	CExtResizableDialog::ShowSizeGrip( FALSE );

	//
	// Enable dialog position saving/restoring in registry
    //
	CExtResizableDialog::EnableSaveRestore(
		__PROF_UIS_PROJECT_DLG_PERSIST_REG_KEY,
		_T("CAboutDlg-Saved-Position")
		);

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// App command to run the dialog
void CMDIDOCVIEWApp::OnAppAbout()
{
CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMDIDOCVIEWApp message handlers

